import json
from oauthlib.oauth2 import BackendApplicationClient
from requests_oauthlib import OAuth2Session

#### Set Variable Values ####

# Hub Account API Credentials #
# https://docs.matillion.com/data-productivity-cloud/api/docs/authentication/ #
client_id = ''
client_secret = ''

# DPC Project, Pipeline and Environment Info #
dpc_region = ''
dpc_api_version = 'v1'
dpc_project_id = ''
dpc_pipeline_name = 'SlackAI App/Slack AI - Main'
dpc_environment = ''

# MatiHelper Required Slack Variables #
ai_pipe_channel_id = ''
ai_notify_webhook_url = ''
ai_webhook_url = ''

#############################

client = BackendApplicationClient(client_id=client_id)
oauth = OAuth2Session(client=client)
token = oauth.fetch_token(token_url='https://id.core.matillion.com/oauth/dpc/token', client_id=client_id,
        client_secret=client_secret)

#print(token)

url = 'https://' + dpc_region + '.api.matillion.com/dpc/' + dpc_api_version + '/projects/' + dpc_project_id + '/pipeline-executions'

headers = {
  'content-type': 'application/json'
}

body = {
  "pipelineName": dpc_pipeline_name,
  "environmentName": dpc_environment,
  "scalarVariables": {
    "pipe_channel_id": ai_pipe_channel_id,
    "pipe_environment": dpc_environment,
    "pipe_notify_webhook_url": ai_notify_webhook_url, 
    "pipe_webhook_url": ai_webhook_url,
    "pipe_dpc_server": dpc_region,
    "pipe_dpc_project_id": dpc_project_id,
    "pipe_dpc_api_version": dpc_api_version
  }
}

resp = oauth.post(url, data=json.dumps(body), headers=headers)

print(resp.json())
